"""HTML to text file converter for Document Library"""

from sgmllib import SGMLParser
from string import join

content_type = ('text/html', 'text/xml', 'text/sgml')

content_description = 'Web Page (HTML)'

# Code taken from Dieter Maurer's CatalogSupport Module
# http://www.handshake.de/~dieter/pyprojects/zope
# Thank you!

class _StripTagParser(SGMLParser):
  '''SGML Parser removing any tags and translating HTML entities.'''

  from htmlentitydefs import entitydefs

  data= None

  def handle_data(self,data):
    if self.data is None: self.data=[]
    self.data.append(data)

  def __str__(self):
    if self.data is None: return ''
    return join(self.data,'')


def convert(doc):
    """Convert html data to raw text"""

    p = _StripTagParser()

    try:
        data = doc.data
        if type(data) == type(''):
            p.feed(data)
        else:
            while data is not None:
                p.feed(data.data)
                data = data.next
        p.close()
        return str(p)
    except:
        return ''
